<?PHP
require "config.php";
require_once "HTML/Table.php";
require_once "formClass.php";

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
//
//  Functions	(Should NOT to be modified)
//
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////
// Function: globalGraph
// Purpose: Function to generate the total records graph. It takes the
//	    arguments to inherit the timeframe defined in the globalView
//	    function.
/////////////////////////////////////////////////////////////////////////
function globalGraph ($offset,$limit) {
        $tableStyle = array("bgcolor"=>"#FFFFFF", "border">0);
        $headTable = new HTML_Table($tableStyle);
        $headTable->addRow(array("<img src='globalGraph.php?offset=$offset&limit=$limit'>", $refTime));
        $headTable->display();
}

/////////////////////////////////////////////////////////////////////////
// Function: portGraph
// Purpose: Function to generate the port trends graph. It takes the
//	    arguments to inherit the timeframe defined in the showView
//	    function.
/////////////////////////////////////////////////////////////////////////
function portGraph ($port,$proto,$offset,$limit) {
	$tableStyle = array("bgcolor"=>"#FFFFFF", "border">0);
	$headTable = new HTML_Table($tableStyle);
	$headTable->addRow(array("<img src='portGraph.php?port=$port&proto=$proto&offset=$offset&limit=$limit'>"));
	$headTable->display();
}

/////////////////////////////////////////////////////////////////////////
// Function: removePort
// Purpose: Function to remove unwanted ports from the database.
/////////////////////////////////////////////////////////////////////////
function removePort ($proto,$remove_port) {
        $sqlquery = "DELETE FROM trends" . $proto . " WHERE port = '$remove_port'";
	print "\n<!-- sqlquery is " . $sqlquery . "-->\n";

	// Build SQL
	$result = $GLOBALS['dbh']->query($sqlquery);
	$GLOBALS['dbh']->disconnect();
	

	// Determine the message content
        if ($result) {
                $msg = "<BR><BRbr>Port <B>" . $remove_port . "</B> deleted from the database.<BR><BR>";
        } else {
                $msg = " There has been an error deleteing " . $remove_port . " from the database \n";
        }

	// Display table
        $tableStyle = array("bgcolor"=>"#DCDCDC", "border">0);
        $table = new HTML_Table($tableStyle);
        $table->addRow(array($msg));
        $table->display();
}

/////////////////////////////////////////////////////////////////////////
// Function: globalView
// Purpose: Function to generate the main page.
/////////////////////////////////////////////////////////////////////////
function globalView () {
	global $config,$plugins,$offset,$numpage,$limit;
	$condition = "date";

	// Pager
	$limit = $config['pagerLimit'];

	// if no offset has been passed, offset should be 0
	if (!$offset) $offset=0;

        $sqlquery = "SELECT DISTINCT date,SUM(totalRecords) AS total,SUM(totalSrcs) AS ts,SUM(totalDsts) AS td 
	             FROM trendsTCP GROUP BY date ORDER BY date DESC";
	$pagerResult = $GLOBALS['dbh']->query($sqlquery);
	// Error Checking
	if (DB::isError($pagerResult)) {
		print "<B>SQL QUERY:</B> " . $sqlquery . "<BR><BR>\n";
		die("SELECT failed: " . $pagerResult->getMessage () . "\n");
	}
	$numrec = $pagerResult->numRows();

	//Calculate the number of pages
	$numpage = intval($numrec/$limit);

	if ($numrec%$limit) {
		$numpage++; // add one page if remainder
	}

	//Append the offset and limit after the number of rows has be calculated
	$sqlquery .= " LIMIT " . $offset . "," . $limit;

	// Make the Call to generate thet total records graph.
	globalGraph($offset,$limit);

	// Print pager menu
	if ($numpage > 1) {
		print "<P>";
		$pageNav = pagenav($offset);
		print "<P>";
	}

	print "\n<!-- sqlquery is " . $sqlquery . "-->\n";

	// Build table headers
	$tableStyle = array("bgcolor"=>"#FFFFFF", "border"=>1);
	$table = new HTML_Table($tableStyle);
	$colHeaders = array(ucwords($condition), "Total Records", "Total Sources", "Total Targets");
	$table->addRow($colHeaders, "", "TH");

	// Calculate all totals
        $totals = updateTotals("trendsTCP", "totalRecords", updateTotals("trendsUDP", "totalRecords", updateTotals("trendsICMP", "totalRecords", updateTotals("trendsIP", "totalRecords"))));
        $totalsrcs = updateTotals("trendsTCP", "totalSrcs", updateTotals("trendsUDP", "totalSrcs", updateTotals("trendsICMP", "totalSrcs", updateTotals("trendsIP", "totalRecords"))));
        $totaldsts = updateTotals("trendsTCP", "totalDsts", updateTotals("trendsUDP", "totalDsts", updateTotals("trendsICMP", "totalDsts", updateTotals("trendsIP", "totalRecords"))));

        foreach ($totals as $key => $value) {
                $row = array ($key,$totals[$key],$totalsrcs[$key],$totaldsts[$key]);
                $row[0] = "<A CLASS='white' HREF=\"summaryView.php?date=" . $row[0] . "\">" . $row[0] . "</A>";
                $table->addRow($row);
        }

        $table->updateColAttributes(0,"bgcolor=#336666");
        $table->display();

	// Print pager menu
	if ($numpage > 1) {
		print "<P>";
		pagenav($offset);
		print "<P>";
	}
}


/////////////////////////////////////////////////////////////////////////
// Function: showView
// Purpose: Function to generate the date and port pages.
/////////////////////////////////////////////////////////////////////////
function showView ($HTTP_GET_VARS) {
	global $config,$plugins,$offset,$numpage;

	// Sanity checking for searching
	if ( isset($HTTP_GET_VARS['proto']) && empty($HTTP_GET_VARS['proto']) ) {
		print "You must select the approperiate protocol\n";
		exit;
	}
		
	if ($HTTP_GET_VARS['proto'] == "ICMP") {
		$field = "typeCode";
	} elseif ($HTTP_GET_VARS['proto'] == "IP") {
		$field = "proto";
	} else {
		$field = "port";
	}

	// Pager
	$limit = $config['pagerLimit'];

	// if no offset has been passed, offset should be 0
	if (!$offset) $offset=0;

	if (isset($HTTP_GET_VARS['date'])) {
		$condition = "port";
		print "<h3 align=\"left\">" . $HTTP_GET_VARS['proto'] . " Protocol for " . $HTTP_GET_VARS['date'] . "</h3\n";
		$sqlquery = "SELECT " . $field . ",SUM(totalRecords),SUM(totalSrcs),SUM(totalDsts) FROM trends" . $HTTP_GET_VARS['proto'] .  
			     " WHERE date = '" . $HTTP_GET_VARS['date'] . "' GROUP BY " . $field . " ORDER BY totalRecords DESC";

	} elseif ( isset($HTTP_GET_VARS['port']) && isset($HTTP_GET_VARS['proto']) ){
		portGraph($HTTP_GET_VARS['port'],$HTTP_GET_VARS['proto'],$offset,$limit);
		$condition = "date";
		$sqlquery = "SELECT date,SUM(totalRecords),SUM(totalSrcs),SUM(totalDsts) FROM trends" . $HTTP_GET_VARS['proto'] . " WHERE "
			     . $field . "='" . $HTTP_GET_VARS['port'] . "' GROUP BY date ORDER BY date DESC";
	}

	$pagerResult = $GLOBALS['dbh']->query($sqlquery);

	// Error Checking
	if (DB::isError($pagerResult)) {
		print "<B>SQL QUERY:</B> " . $sqlquery . "<BR><BR>\n";
		die("SELECT failed: " . $pagerResult->getMessage () . "\n");
	}

	$numrec = $pagerResult->numRows();

	//Calculate the number of pages
	$numpage = intval($numrec/$limit);

	if ($numrec%$limit) {
		$numpage++; // add one page if remainder
	}

	// Append the offset and limit after the number of rows has be calculated
	$sqlquery .= " LIMIT " . $offset . "," . $limit;

	// Print pager menu
	if ($numpage > 1) {
		print "<P>";
		pagenav($offset);
		print "<P>";
	}

	print "<!-- sqlquery is " . $sqlquery . "-->\n";

	// Build table headers and form
	$form = new form(array("action"=>"index.php?remove_port", "method"=>"get"));
	print $form->addHidden(array("proto", $HTTP_GET_VARS['proto']));
	$tableStyle = array("bgcolor"=>"#FFFFFF", "border"=>1);
	$table = new HTML_Table($tableStyle);
	$colHeaders = array(ucwords($condition), "Total Records", "Total Sources", "Total Targets");
	if ($condition == "port" && isset($plugins['sensorLens'])) {
		$colHeaders[] = "Plug-ins";
	}
	$table->addRow($colHeaders, "", "TH");

	// Build SQL
        $result = $GLOBALS['dbh']->query($sqlquery);

	// Error Checking
	if (DB::isError($result)) {
		print "<B>SQL QUERY:</B> " . $sqlquery . "<BR><BR>\n";
		die("SELECT failed: " . $result->getMessage () . "\n");
	}
        while($row = $result->fetchRow()){

		///////////////
		// port query
		///////////////
		if ( $condition == "port" ) {
			$portname = resolvePort($row[0],$HTTP_GET_VARS['proto']);

			if ( isset($plugins['sensorLens']) ) {
				$row[] = "<A HREF=\"" . $plugins['sensorLens'] . "/search.php?dstport=" . $row[0] . "\">
					  <IMG SRC=\"" . $config['images'] . "/metal-magnifying-glass.jpg\" BORDER=\"0\" HEIGHT=\"20\" WIDTH=\"27\"></A>";
			}
				
			if ( $portname != $row[0] ) {
				$portname = $portname . "&nbsp;&nbsp;(" . $row[0] . ")";
			}

			$row[0] = $form->addRadio(array("remove_port", $row[0])) . "&nbsp;&nbsp;<A CLASS=\"white\" href=\"index.php?port=" . $row[0] . 
				  "&proto=" . $HTTP_GET_VARS['proto'] . "\">" . $portname . "</A>";
		}

		///////////////
		// date query
		///////////////
		elseif ( $condition == "date" ) {

			// Add a link to the date
			$row[0] = "<A CLASS=\"white\" href=\"summaryView.php?date=" . $row[0] . "\">" . $row[0] . "</A>";

		}

		$table->addRow($row);
		$table->updateColAttributes(0,"bgcolor=#336666");
	}

	// Close the table and disconnect from the DB
	$table->display();
	$GLOBALS['dbh']->disconnect();

	// Add the submit button 
	if ( $condition == "port" ) {
		print "<br> " . $form->addSubmit("Remove");
		$form->endForm();
	}

	// Add the pager menu
        if ($numpage > 1) {
                print "<P>";
                pagenav($offset);
                print "<P>";
        }
}

/////////////////////////////////////////////////////////////////////////
// Function: resolvePort
// Purpose: Accepts one numeric argument and attempts to resolve the 
// 	    port number to a service name. A lookup is done on the
//	    /etc/service file. Custom entries can be added to provide
//	    more descriptive output via the web interface.
/////////////////////////////////////////////////////////////////////////
function resolvePort ($port,$proto) {
	global $typeCodeRef;

	if (($proto == "TCP") || ($proto == "UDP")) {
		$portName = getservbyport($port, strtolower($proto));
	} elseif ($proto == "IP") {
		$portName = getprotobynumber($port);
	} elseif ($proto == "ICMP") {
		$portName = $typeCodeRef[$port];
	}

	if ( empty($portName) ) {
		$portName = $port;
	}

	return $portName;
}


/////////////////////////////////////////////////////////////////////////
// Function: pagenav
// Purpose: Figures out how many total pages are in the query based on
//	    the configured limit ($config['pagerLimit']) defined in
//	    config.php. This function also builds the HTML display.
/////////////////////////////////////////////////////////////////////////
function pagenav($offset) {
	global $config,$limit,$numpage;
	$limit = $config['pagerLimit'];

        // Deal with the Query String to remove Duplicate and offset
        if ($_SERVER['QUERY_STRING']) {
                parse_str($_SERVER['QUERY_STRING'], $queryArray);
                foreach ($queryArray as $key => $value) {
                        if ($key != "offset") {
                                $newArray[] = $key . "=" . $value;
                        }
                }
		// Offset is the only querystring, dont build qString.
		if (!empty($newArray)) {
                	$qString = implode('&',$newArray);
		}
        }

	// Build a stream-lined pager menu
	// First
	if ($offset > 1) {
		$newoff = 0;
		if (isset($qString)) {
			$pagerAtoms[] = "<A HREF=\"" . $PHP_SELF . "?" . $qString . "&offset=" . $newoff . "\">First</A>";
		} else {
			$pagerAtoms[] = "<A HREF=\"" . $PHP_SELF . "?offset=" . $newoff . "\">First</A>";
		}
	} else {
		$pagerAtoms[] = "First";
	}

	// Last
	if (isset($offset)) {
		$newoff = ($limit * ($numpage - 1));
		if (isset($qString)) {
			$pagerAtoms[] = "<A HREF=\"" . $PHP_SELF . "?" . $qString . "&offset=" . $newoff . "\">Last</A>";
		} else {
			$pagerAtoms[] = "<A HREF=\"" . $PHP_SELF . "?offset=" . $newoff . "\">Last</A>";
		}
	} else {
		$pagerAtoms[] = "Last";
	}

	// Previous
	if ($offset >= $limit) {
		$newoff = $offset - $limit;
		if (isset($qString)) {
			$pagerAtoms[] = "<A HREF=\"" . $PHP_SELF . "?" . $qString . "&offset=" . $newoff . "\">Previous</A>";
		} else {
			$pagerAtoms[] = "<A HREF=\"" . $PHP_SELF . "?offset=" . $newoff . "\">Previous</A>";
		}
	} else {
		$pagerAtoms[] = "Previous";
	}

	// Next
	if ($offset != $limit * ($numpage - 1)) {
		$newoff = $offset + $limit;
		if (isset($qString)) {
			$pagerAtoms[] = "<A HREF=\"" . $PHP_SELF . "?" . $qString . "&offset=" . $newoff . "\">Next</A>";
		} else {
			$pagerAtoms[] = "<A HREF=\"" . $PHP_SELF . "?offset=" . $newoff . "\">Next</A>";
		}
	} else {
		$pagerAtoms[] = "Next";
	}

	// X of X page
	$pagerAtoms[] = "(" . ($offset / $limit + 1) . " of " . $numpage . ")";

	print $pagerMenu = implode(" / ", $pagerAtoms);
}

/////////////////////////////////////////////////////////////////////////
// Function: updateTotals
// Purpose: Used to generate the sum of all totalRecords fields 
//          specified tables.
/////////////////////////////////////////////////////////////////////////
function updateTotals ($tableName, $fieldName="totalRecords", $totals=array(), $date=FALSE) {

	$sqlquery = "SELECT DISTINCT date,sum(" . $fieldName . ") AS TR FROM " . $tableName;
	if ($date) {
		$sqlquery .= " WHERE date = '" . addslashes($date) . "'";
		$sqlquery .= " GROUP BY date ORDER BY date DESC";
	} else {
		$sqlquery .= " GROUP BY date ORDER BY date DESC LIMIT " . $GLOBALS['offset'] . "," . $GLOBALS['limit'];
	}

	$result = $GLOBALS['dbh']->query($sqlquery);

	// Error Checking
	if (DB::isError($result)) {
		print "<B>SQL QUERY:</B> " . $sqlquery . "<BR><BR>\n";
		die("SELECT failed: " . $result->getMessage () . "\n");
	}

	while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)){
		$totals[$row["date"]] += $row["TR"];

	}
	return $totals;
}

?>
